# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2016_08_01
  module Models
    #
    # User crendentials used for publishing activity.
    #
    class Deployment < ProxyOnlyResource

      include MsRestAzure

      # @return [String] Identifier for deployment.
      attr_accessor :deployment_id

      # @return [Integer] Deployment status.
      attr_accessor :status

      # @return [String] Details about deployment status.
      attr_accessor :message

      # @return [String] Who authored the deployment.
      attr_accessor :author

      # @return [String] Who performed the deployment.
      attr_accessor :deployer

      # @return [String] Author email.
      attr_accessor :author_email

      # @return [DateTime] Start time.
      attr_accessor :start_time

      # @return [DateTime] End time.
      attr_accessor :end_time

      # @return [Boolean] True if deployment is currently active, false if
      # completed and null if not started.
      attr_accessor :active

      # @return [String] Details on deployment.
      attr_accessor :details


      #
      # Mapper for Deployment class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Deployment',
          type: {
            name: 'Composite',
            class_name: 'Deployment',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              deployment_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.id',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.status',
                type: {
                  name: 'Number'
                }
              },
              message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.message',
                type: {
                  name: 'String'
                }
              },
              author: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.author',
                type: {
                  name: 'String'
                }
              },
              deployer: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.deployer',
                type: {
                  name: 'String'
                }
              },
              author_email: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.authorEmail',
                type: {
                  name: 'String'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.startTime',
                type: {
                  name: 'DateTime'
                }
              },
              end_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.endTime',
                type: {
                  name: 'DateTime'
                }
              },
              active: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.active',
                type: {
                  name: 'Boolean'
                }
              },
              details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.details',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
