# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2020_09_01
  module Models
    #
    # Current TCP connectivity information from the App Service Environment to
    # a single endpoint.
    #
    class EndpointDetail

      include MsRestAzure

      # @return [String] An IP Address that Domain Name currently resolves to.
      attr_accessor :ip_address

      # @return [Integer] The port an endpoint is connected to.
      attr_accessor :port

      # @return [Float] The time in milliseconds it takes for a TCP connection
      # to be created from the App Service Environment to this IpAddress at
      # this Port.
      attr_accessor :latency

      # @return [Boolean] Whether it is possible to create a TCP connection
      # from the App Service Environment to this IpAddress at this Port.
      attr_accessor :is_accessible


      #
      # Mapper for EndpointDetail class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EndpointDetail',
          type: {
            name: 'Composite',
            class_name: 'EndpointDetail',
            model_properties: {
              ip_address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ipAddress',
                type: {
                  name: 'String'
                }
              },
              port: {
                client_side_validation: true,
                required: false,
                serialized_name: 'port',
                type: {
                  name: 'Number'
                }
              },
              latency: {
                client_side_validation: true,
                required: false,
                serialized_name: 'latency',
                type: {
                  name: 'Double'
                }
              },
              is_accessible: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isAccessible',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
